//
//  Items.m
//
//  Created by 杰 张 on 16/7/18
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "Items.h"


NSString *const kItemsAmount = @"amount";
NSString *const kItemsRemark = @"remark";
NSString *const kItemsEndDate = @"endDate";
NSString *const kItemsUnpaid = @"unpaid";
NSString *const kItemsSubject = @"subject";
NSString *const kItemsBeginDate = @"beginDate";
NSString *const kItemsDirection = @"direction";
NSString *const kItemsPaid = @"paid";


@interface Items ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation Items

@synthesize amount = _amount;
@synthesize remark = _remark;
@synthesize endDate = _endDate;
@synthesize unpaid = _unpaid;
@synthesize subject = _subject;
@synthesize beginDate = _beginDate;
@synthesize direction = _direction;
@synthesize paid = _paid;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.amount = [[self objectOrNilForKey:kItemsAmount fromDictionary:dict] doubleValue];
            self.remark = [self objectOrNilForKey:kItemsRemark fromDictionary:dict];
            self.endDate = [[self objectOrNilForKey:kItemsEndDate fromDictionary:dict] doubleValue];
            self.unpaid = [[self objectOrNilForKey:kItemsUnpaid fromDictionary:dict] doubleValue];
            self.subject = [self objectOrNilForKey:kItemsSubject fromDictionary:dict];
            self.beginDate = [[self objectOrNilForKey:kItemsBeginDate fromDictionary:dict] doubleValue];
            self.direction = [[self objectOrNilForKey:kItemsDirection fromDictionary:dict] doubleValue];
            self.paid = [[self objectOrNilForKey:kItemsPaid fromDictionary:dict] doubleValue];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:[NSNumber numberWithDouble:self.amount] forKey:kItemsAmount];
    [mutableDict setValue:self.remark forKey:kItemsRemark];
    [mutableDict setValue:[NSNumber numberWithDouble:self.endDate] forKey:kItemsEndDate];
    [mutableDict setValue:[NSNumber numberWithDouble:self.unpaid] forKey:kItemsUnpaid];
    [mutableDict setValue:self.subject forKey:kItemsSubject];
    [mutableDict setValue:[NSNumber numberWithDouble:self.beginDate] forKey:kItemsBeginDate];
    [mutableDict setValue:[NSNumber numberWithDouble:self.direction] forKey:kItemsDirection];
    [mutableDict setValue:[NSNumber numberWithDouble:self.paid] forKey:kItemsPaid];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.amount = [aDecoder decodeDoubleForKey:kItemsAmount];
    self.remark = [aDecoder decodeObjectForKey:kItemsRemark];
    self.endDate = [aDecoder decodeDoubleForKey:kItemsEndDate];
    self.unpaid = [aDecoder decodeDoubleForKey:kItemsUnpaid];
    self.subject = [aDecoder decodeObjectForKey:kItemsSubject];
    self.beginDate = [aDecoder decodeDoubleForKey:kItemsBeginDate];
    self.direction = [aDecoder decodeDoubleForKey:kItemsDirection];
    self.paid = [aDecoder decodeDoubleForKey:kItemsPaid];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeDouble:_amount forKey:kItemsAmount];
    [aCoder encodeObject:_remark forKey:kItemsRemark];
    [aCoder encodeDouble:_endDate forKey:kItemsEndDate];
    [aCoder encodeDouble:_unpaid forKey:kItemsUnpaid];
    [aCoder encodeObject:_subject forKey:kItemsSubject];
    [aCoder encodeDouble:_beginDate forKey:kItemsBeginDate];
    [aCoder encodeDouble:_direction forKey:kItemsDirection];
    [aCoder encodeDouble:_paid forKey:kItemsPaid];
}

- (id)copyWithZone:(NSZone *)zone
{
    Items *copy = [[Items alloc] init];
    
    if (copy) {

        copy.amount = self.amount;
        copy.remark = [self.remark copyWithZone:zone];
        copy.endDate = self.endDate;
        copy.unpaid = self.unpaid;
        copy.subject = [self.subject copyWithZone:zone];
        copy.beginDate = self.beginDate;
        copy.direction = self.direction;
        copy.paid = self.paid;
    }
    
    return copy;
}


@end
