//
//  StatementModel.m
//
//  Created by 杰 张 on 16/7/18
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import "StatementModel.h"
#import "Items.h"


NSString *const kStatementModelAmount = @"amount";
NSString *const kStatementModelSettle = @"settle";
NSString *const kStatementModelUnpaid = @"unpaid";
NSString *const kStatementModelPicture = @"picture";
NSString *const kStatementModelContract = @"contract";
NSString *const kStatementModelShopName = @"shopName";
NSString *const kStatementModelShopCode = @"shopCode";
NSString *const kStatementModelPaid = @"paid";
NSString *const kStatementModelState = @"state";
NSString *const kStatementModelItems = @"items";


@interface StatementModel ()

- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict;

@end

@implementation StatementModel

@synthesize amount = _amount;
@synthesize settle = _settle;
@synthesize unpaid = _unpaid;
@synthesize picture = _picture;
@synthesize contract = _contract;
@synthesize shopName = _shopName;
@synthesize shopCode = _shopCode;
@synthesize paid = _paid;
@synthesize state = _state;
@synthesize items = _items;


+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict
{
    return [[self alloc] initWithDictionary:dict];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    self = [super init];
    
    // This check serves to make sure that a non-NSDictionary object
    // passed into the model class doesn't break the parsing.
    if(self && [dict isKindOfClass:[NSDictionary class]]) {
            self.amount = [[self objectOrNilForKey:kStatementModelAmount fromDictionary:dict] doubleValue];
            self.settle = [self objectOrNilForKey:kStatementModelSettle fromDictionary:dict];
            self.unpaid = [[self objectOrNilForKey:kStatementModelUnpaid fromDictionary:dict] doubleValue];
            self.picture = [self objectOrNilForKey:kStatementModelPicture fromDictionary:dict];
            self.contract = [self objectOrNilForKey:kStatementModelContract fromDictionary:dict];
            self.shopName = [self objectOrNilForKey:kStatementModelShopName fromDictionary:dict];
            self.shopCode = [self objectOrNilForKey:kStatementModelShopCode fromDictionary:dict];
            self.paid = [[self objectOrNilForKey:kStatementModelPaid fromDictionary:dict] doubleValue];
            self.state = [self objectOrNilForKey:kStatementModelState fromDictionary:dict];
    NSObject *receivedItems = [dict objectForKey:kStatementModelItems];
    NSMutableArray *parsedItems = [NSMutableArray array];
    if ([receivedItems isKindOfClass:[NSArray class]]) {
        for (NSDictionary *item in (NSArray *)receivedItems) {
            if ([item isKindOfClass:[NSDictionary class]]) {
                [parsedItems addObject:[Items modelObjectWithDictionary:item]];
            }
       }
    } else if ([receivedItems isKindOfClass:[NSDictionary class]]) {
       [parsedItems addObject:[Items modelObjectWithDictionary:(NSDictionary *)receivedItems]];
    }

    self.items = [NSArray arrayWithArray:parsedItems];

    }
    
    return self;
    
}

- (NSDictionary *)dictionaryRepresentation
{
    NSMutableDictionary *mutableDict = [NSMutableDictionary dictionary];
    [mutableDict setValue:[NSNumber numberWithDouble:self.amount] forKey:kStatementModelAmount];
    [mutableDict setValue:self.settle forKey:kStatementModelSettle];
    [mutableDict setValue:[NSNumber numberWithDouble:self.unpaid] forKey:kStatementModelUnpaid];
    [mutableDict setValue:self.picture forKey:kStatementModelPicture];
    [mutableDict setValue:self.contract forKey:kStatementModelContract];
    [mutableDict setValue:self.shopName forKey:kStatementModelShopName];
    [mutableDict setValue:self.shopCode forKey:kStatementModelShopCode];
    [mutableDict setValue:[NSNumber numberWithDouble:self.paid] forKey:kStatementModelPaid];
    [mutableDict setValue:self.state forKey:kStatementModelState];
    NSMutableArray *tempArrayForItems = [NSMutableArray array];
    for (NSObject *subArrayObject in self.items) {
        if([subArrayObject respondsToSelector:@selector(dictionaryRepresentation)]) {
            // This class is a model object
            [tempArrayForItems addObject:[subArrayObject performSelector:@selector(dictionaryRepresentation)]];
        } else {
            // Generic object
            [tempArrayForItems addObject:subArrayObject];
        }
    }
    [mutableDict setValue:[NSArray arrayWithArray:tempArrayForItems] forKey:kStatementModelItems];

    return [NSDictionary dictionaryWithDictionary:mutableDict];
}

- (NSString *)description 
{
    return [NSString stringWithFormat:@"%@", [self dictionaryRepresentation]];
}

#pragma mark - Helper Method
- (id)objectOrNilForKey:(id)aKey fromDictionary:(NSDictionary *)dict
{
    id object = [dict objectForKey:aKey];
    return [object isEqual:[NSNull null]] ? nil : object;
}


#pragma mark - NSCoding Methods

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];

    self.amount = [aDecoder decodeDoubleForKey:kStatementModelAmount];
    self.settle = [aDecoder decodeObjectForKey:kStatementModelSettle];
    self.unpaid = [aDecoder decodeDoubleForKey:kStatementModelUnpaid];
    self.picture = [aDecoder decodeObjectForKey:kStatementModelPicture];
    self.contract = [aDecoder decodeObjectForKey:kStatementModelContract];
    self.shopName = [aDecoder decodeObjectForKey:kStatementModelShopName];
    self.shopCode = [aDecoder decodeObjectForKey:kStatementModelShopCode];
    self.paid = [aDecoder decodeDoubleForKey:kStatementModelPaid];
    self.state = [aDecoder decodeObjectForKey:kStatementModelState];
    self.items = [aDecoder decodeObjectForKey:kStatementModelItems];
    return self;
}

- (void)encodeWithCoder:(NSCoder *)aCoder
{

    [aCoder encodeDouble:_amount forKey:kStatementModelAmount];
    [aCoder encodeObject:_settle forKey:kStatementModelSettle];
    [aCoder encodeDouble:_unpaid forKey:kStatementModelUnpaid];
    [aCoder encodeObject:_picture forKey:kStatementModelPicture];
    [aCoder encodeObject:_contract forKey:kStatementModelContract];
    [aCoder encodeObject:_shopName forKey:kStatementModelShopName];
    [aCoder encodeObject:_shopCode forKey:kStatementModelShopCode];
    [aCoder encodeDouble:_paid forKey:kStatementModelPaid];
    [aCoder encodeObject:_state forKey:kStatementModelState];
    [aCoder encodeObject:_items forKey:kStatementModelItems];
}

- (id)copyWithZone:(NSZone *)zone
{
    StatementModel *copy = [[StatementModel alloc] init];
    
    if (copy) {

        copy.amount = self.amount;
        copy.settle = [self.settle copyWithZone:zone];
        copy.unpaid = self.unpaid;
        copy.picture = [self.picture copyWithZone:zone];
        copy.contract = [self.contract copyWithZone:zone];
        copy.shopName = [self.shopName copyWithZone:zone];
        copy.shopCode = [self.shopCode copyWithZone:zone];
        copy.paid = self.paid;
        copy.state = [self.state copyWithZone:zone];
        copy.items = [self.items copyWithZone:zone];
    }
    
    return copy;
}


@end
